//*****************************************************************************
//
//	Coordinator.m  
//		
//		NXApp delegate, central control object for GateKeeper 
// 
//			by	Felipe A. Rodriguez		
//
//	This code is supplied "as is" the author makes no warranty as to its 
//	suitability for any purpose.  This code is free and may be distributed 
//	in accordance with the terms of the:
//		
//			GNU GENERAL PUBLIC LICENSE
//			Version 2, June 1991
//			copyright (C) 1989, 1991 Free Software Foundation, Inc.
// 			675 Mass Ave, Cambridge, MA 02139, USA
//
//*****************************************************************************

#import <objc/Object.h>
#import <appkit/Application.h>
#import <appkit/nextstd.h>
#import "GKdefs.h"




@interface Coordinator:Object
{
	id  theIconView;
	id  theAnimator;
	id  onImage;			// pointer to our "linked" tiff
	NXRect bRect;
	id  timeCell;
    id	commandView;
    id	statusView;
    id	statusImageView;
    id	connectionSpeedField;
    id	timeField;
    id	providerField;
    id	statusButton;
    id	dial;
    id  infoPanel;					// The Info... panel 
    id  helpPanel;			/* outlet to our help panel */
    id  preferencesPanel;		/* The Preferences panel */
    id	stringTable;
	id  theTimer;
	id  theOpenButton;
	id  theGateDocEditor;
	id  theOptionsEditor;
	char lastCall[MAXPATHLEN + 1];	 // stores path of last .Gate doc invoked
	id theGateServer;			// distributed objects server
	id GateConnection;			// distributed objects server
	char Path[MAXPATHLEN + 1];	// generic buffer to hold paths
	char BPath[MAXPATHLEN + 1];	// generic buffer to hold paths
	id  toolBar;				// our tool bar 
    char *capturedStr[4];		// ptr array to address str's and baud str
	id  iTimer;					// the Idle Timer controller 
	id  Parser;					// pattern search object
	int backOffDelay;			// delay to backoff on consecutive redials
	int backOffDefault;			// backoff delay default value
	id  hotListDelegate;		// hotlist window's delegate
	BOOL appIconTime;			// display online time in app icon
    NXZone *idleZone;			// zone containing idle timeout mechanism
	BOOL pppstats;				// whether pppstats is enabled and socket open
	id  cDaemonButton;			// control daemon button
	BOOL manDial;				// prior session was mandial
	BOOL wasHidden;				// 
}

- showInfo:sender;
- preferences:sender;
- showHelpPanel:sender;
- showStatusPanel:sender; 
- showConsole:sender;
- showTimerPanel:sender; 

- pppstats:aView;
- pppstats;
- viewLog:sender;
- controlDaemon:sender; 
- Dial:sender;  
- DOFinished;
- disconnect:sender;  
- killDaemon;
- showMenuTimer:(char *)buffer; 
- gotIt;
- displayLinkStatus;
- setPhase:(int)phase;
- fifo;
- toolBar:sender;
- readable:(const char *)nameOfFile;
- optionsEditor;
- appIconView;
- (BOOL)mailInQueue; 
- runScript:(const char *)type;  
- connectedAt:(const char *)speed;  
- linkWithFile:(const char *)path;  
- (BOOL)debugFlag:(const char *)optionFile;
- hotListDelegate; 
- setAppIconTimer:(BOOL)onOff; 
- stringTable;
- commandView;
- showAlert:(const char *)errorString;
- (const char *)localString:(const char *)aString;
- loadBundle:(const char *)p ofType:(const char *)bType owner:o nib:(BOOL)lNib;
- loadBundlesOfType:(const char *)bundleType owner:o nib:(BOOL)loadNib;

	// Application Object Delegation
- appDidInit:sender;
- appWillTerminate:sender;
- (int)app:sender openFile:(const char *)path type:(const char *)type; 
- (BOOL)appAcceptsAnotherFile:sender; 
- appDidUnhide:sender;
- appDidHide:sender;

	// Window Object Delegation
- windowWillMiniaturize:sender toMiniwindow:miniwindow; 

@end

