//*****************************************************************************
//
//	DialServer.h.  
//
//		Distributed Objects server which communicates with MODEM tool
//		during Manual dial.
//
//			by	Felipe A. Rodriguez		
//
//	This code is supplied "as is" the author makes no warranty as to its 
//	suitability for any purpose.  This code is free and may be distributed 
//	in accordance with the terms of the:
//		
//			GNU GENERAL PUBLIC LICENSE
//			Version 2, June 1991
//			copyright (C) 1989, 1991 Free Software Foundation, Inc.
// 			675 Mass Ave, Cambridge, MA 02139, USA
//
//*****************************************************************************

#import <appkit/appkit.h>




@interface DialServer:Object <NXSenderIsInvalid>
{
	id  phoneNumField;
	id  gateToolProxy;			// distributed objects proxy for the GateTool
    id  gatePanel;				/* The Gate Tool panel */
    id  theInspector;			/* The Gate Tool panel */
	char Path[MAXPATHLEN + 1];	// generic buffer to hold paths
	id  theOptionsEditor;
	BOOL shouldExit;			// whether MODEM should exit 
	BOOL connecting;			// port invalidation because of connection
}

- senderIsInvalid:sender; 
- showDialPanel; 
- Dial:sender;  
- cancelDial:sender;  
- hangUp:sender;  
- activateGateKeeper;  
- Attach:sender;  
- (const char *)modemInit;
- (const char *)modemPort;  
- (const char *)modemSpeed;  
- (BOOL)shouldExit; 
- appWillTerminate;

@end
@protocol serverProtocol

- writePty:(char *)buffer;
- (void)enScript:(char *)buffer;
- setPty:(int)pty;
- unlockSerialPort;

@end

