//*****************************************************************************
//
//	OptionsEditor.h.  
//		
//		Edit the options file contained within a Gate doc 
// 
//		by	Felipe A. Rodriguez		
//
//	This code is supplied "as is" the author makes no warranty as to its 
//	suitability for any purpose.  This code is free and may be distributed 
//	in accordance with the terms of the:
//		
//			GNU GENERAL PUBLIC LICENSE
//			Version 2, June 1991
//			copyright (C) 1989, 1991 Free Software Foundation, Inc.
// 			675 Mass Ave, Cambridge, MA 02139, USA
//
//*****************************************************************************


#import <appkit/appkit.h>


@interface OptionsEditor:Object
{
    id  editDoc;			// edit .Gate doc window
	id	swMatrix;			// pref check box matrix of switches
    id  editWin;			// edit .Gate doc window
	BOOL defaultroute;
	BOOL lockFlag;
	BOOL crtscts;
	BOOL debug;
	BOOL shouldSave;
	char path[MAXPATHLEN + 1];		// generic buffer to hold paths
    char Path[MAXPATHLEN + 1];
    id  dvPopupList;				// popuplist
    id  dvPopup;					// button cover for popuplist
    id  dvPopMtrx;					// dev name popuplist matrix
    char devName[MAXPATHLEN + 1];
    id  spPopupList;				// popuplist
    id  spPopup;					// button cover for popuplist
    id  spPopMtrx;					// speed popuplist matrix
    char speed[MAXPATHLEN + 1];
    id  owner;						// object that owns us
}

- init;
- parseOptionsFile:(const char *)filePath;
- parseOptions:(const char *)filePath;
- switch:sender;
- setDefaultRoute;
- (BOOL)defaultRoute;
- setShouldSave:sender;
- (BOOL)shouldSave;
- setLockFlag;
- (BOOL)lockFlag;
- setDebug;
- (BOOL)debug;
- setCrtscts;
- (BOOL)crtscts;
- setDevName:(const char *)device;
- (const char *)devName;
- devPopUpAction:sender;
- setSpeed:(const char *)aSpeed;
- (const char *)speed;
- speedPopUpAction:sender;
- editorWindow;
- editOptions:sender;
- editPppup:sender;
- setOwner:anObject;


@end
