//*****************************************************************************
//
//	Parse.h.  
//		
//		Search a file for a specific pattern of (2)strings which will 
//		identify the next str as a keyword to be captured and returned.
// 
//		by	Felipe A. Rodriguez		
//
//	This code is supplied "as is" the author makes no warranty as to its 
//	suitability for any purpose.  This code is free and may be distributed 
//	in accordance with the terms of the:
//		
//			GNU GENERAL PUBLIC LICENSE
//			Version 2, June 1991
//			copyright (C) 1989, 1991 Free Software Foundation, Inc.
// 			675 Mass Ave, Cambridge, MA 02139, USA
//
//*****************************************************************************


#import <appkit/appkit.h>

@interface Parse:Object
{
	const char *keyOne;			// first keyword searched for in parse: method
	const char *keyTwo;			// second keyword searched for in parse: method
	const char *delim1;			// delimiters used in parse: method
	const char *delim2;			// delimiters used in parse: method
	char lBuf[MAXPATHLEN + 50];	// generic buffer to hold lines of text
}

- setDelim1:(const char *)delimiters;
- setDelim2:(const char *)delimiters;
- setKey1:(const char *)keyWord;
- setKey2:(const char *)keyWord;
- (char *)parseFile:(const char *)filePath;
- (char *)parse:(char *)buffer;


@end
