//*****************************************************************************
//
//	Preferences.m.  
//
//		Preferences logic.
//
//			by	Felipe A. Rodriguez		
//
//	This code is supplied "as is" the author makes no warranty as to its 
//	suitability for any purpose.  This code is free and may be distributed 
//	in accordance with the terms of the:
//		
//			GNU GENERAL PUBLIC LICENSE
//			Version 2, June 1991
//			copyright (C) 1989, 1991 Free Software Foundation, Inc.
// 			675 Mass Ave, Cambridge, MA 02139, USA
//
//*****************************************************************************

#import "Preferences.h"
#import "PreferencesPanelController.h"
#import "SwapView.h"
#import <sys/types.h>
#import <sys/dir.h>  



@implementation Preferences

//*****************************************************************************
//
//		sent to us after nib objects are unarchived and init'd 
//
//*****************************************************************************
 
- awakeFromNib 
{
NXRect graphRect;							// sizeof scroll's content view

						// remem loc/size
	[[swapView window] setFrameAutosaveName:[[swapView window] title]]; 

						// adjust button preference scrollview's behaviour
	[prefScrollView setBorderType: NX_BEZEL];
	[prefScrollView setHorizScrollerRequired:YES];
	[prefScrollView setVertScrollerRequired:NO];
	[prefScrollView setLineScroll:2];

	[prefScrollView getFrame:&graphRect];
	bView = [[View alloc] initFrame:&graphRect];
	[prefScrollView setDocView:bView];
	
    return self;
}
//*****************************************************************************
//
//		swap preferences subviews, dynamically loads it if necessary
//
//*****************************************************************************

- loadPreference:(const char *)pControl ofClass:aClass button:sender
{
id iPanelController;

   if(!NXGetNamedObject(pControl, NXApp))
		{
		if(![[NXBundle bundleForClass:aClass] getPath:Path forResource:pControl
																ofType:"nib"])
			NXRunAlertPanel(0, "Error getting nib path", 0, 0, 0);
		else
			[NXApp loadNibFile:Path owner:NXApp withNames:YES 
												 fromZone:[self zone]];

		if(!(iPanelController = NXGetNamedObject(pControl, NXApp)))
			NXRunAlertPanel(0, "Error getting named object", 0, 0, 0);
		[swapView addInspector:[iPanelController inspectorPanel] for:sender];
		}
	[swapView inspectorFor:sender];
	[[swapView window] makeKeyAndOrderFront:self];

    return self;
}

@end

